Unit           EA_IO;

{ Aus unserem Terminalprogramm Terminal V1.3 oder TERM9719}
{  8.3.95RT: Version 0.0 }
{  6.7.95RT: Auf 19200 Baud erweitert }
{ 14.9.95RT: Anzeige in HEX,DEZ und ASCII }
{ 21.9.95RT: Anzeige Mix/HEX/ASCII ber Shift F1 umschaltbar }
{  9.1.96RT: LPT1 und SYNC1 eingebaut }
{ 11.1.96RT: Terminal(V1.3): LPT1 luft nun ber LST; Code 26(dez) geht jetzt }
{ 19.2.96RT: CTS- und Sendepufferleer-Abfrage, 38400,57600 und 115200 Baud }
{  7.5.96RT: rechnerunabhngige Warte-routinen eingebaut}
{  7.5.97RT: erweiterte Tastaturabfrage }

interface


uses crt,dos,printer;



procedure io_cli; inline($fa);
procedure io_sti; inline($fb);

{----------------------------------------------------------------------------
      DumbTerm is an example program written to demonstrate the use of both
 interrupt routines and com port communication.

Upgraded to Turbo Pascal 4.0                   written by,
  By Kevin Nixon                                  Jim McCarthy
  HB Design Group                                 Technical Support
Added 2400 baud support                           Borland International

                                                and
                                                  Andy Batony
                                                  Teleware Incorporated

-----------------------------------------------------------------------------}



  const
    hex        : array[0..15] of Char= '0123456789ABCDEF'; { constant used to convert }
                                                  { decimal to hex           }
    com1_intr  = $0c;                         { interrupt number of com1     }
    com2_intr  = $0b;                         { interrupt number of com2?    }
    irq4       = $30;                         { Interrupt vector address for }
                                              { COM1.                        }
    irq3       = $2C;                         { Vector for COM2.             }
    eoi        = $20;                         {                              }
    com1base   = $03F8;                       { Port address of COM1.        }
    com2base   = $02F8;                       { Port address of COM2.        }
                                              { Offset to add to com#base for}
    intenreg   = 1;                           {   Interrupt enable register  }
    intidreg   = 2;                           {   Interrupt id register      }
    linectrl   = 3;                           {   Line control register      }
    modemctrl  = 4;                           {   Modem control register     }
    linestat   = 5;                           {   Line status register       }
    modemstat  = 6;                           {   Modem status register      }
    buffsize   = 1024;                        { Size of the ring buffer      }
    ESC        = 27;

  type                                        { type declarations            }
    str4       = string[4];
    str80      = string[80];
    ratetype   = (rate300,rate1200,rate2400,rate4800,rate9600,rate19200,rate38400,rate57600,rate115200);
    comtype    = (com1,com2,lpt1,sync1);
    bytechar   = record case boolean of
                   true :(o:byte);
                   false:(c:char)
                 end;


  var
    intbuffer    : array [0..buffsize] of bytechar;    { Ring buffer         }
    oldvecaddr : pointer;                     { Address of DOS set           }
                                              { Offset of DOS set com int.   }
    head,                                     { Index to the head of the     }
                                              { ring buffer.                 }
    tail,                                     { Tail index of the ring buff  }
    comport,                                  { Comport address              }
    i            : integer;                   { Counter                      }
    comp         : comtype;                   { used to specify which comport}
    ch,                                       { Temperary character buffer   }
    kch,kch2     : char;                      { Char keyed in from the key-  }
                                              { board                        }
    temp         : string[80];                { Temperary buffer             }
    tbyte,
    lbyte        : byte;
    showok       : boolean;
    reg_set      : registers;                 { Registers used in DOS call   }
    zahl  : byte;                             { fuer die HEX Umwandlung }
    code,zehner,einer  : integer;             {                         }
    X_Pos,Y_Pos  : byte;                       { fuer Programmabbruch }
    Zeichen_pro_Zeile: Byte;                   { fr Hex Dump }
    Anzeige      : Byte;                       { 1:gemischt 2:HEX 3:ASCII}
    Datei        : File of Byte;               { fr Ausgabe auf LPT1 }
    Bilddatei    : File of Byte;               { zum Abspeichern von Bildern }
    Dateiname    : String[50];                 { z.B. 9720BILD.000 }
    Wert         : Byte;
    Laenge       : Integer;                    { Schleifenzhler, Bildlnge }
    Bild_Nr      : Integer;                    { Zhler Anzahl abgelegter Bilder}
    regs         : registers;
                                               { fr KeyState }
  Const
    R_Shift      : Byte=  1;
    L_Shift      : Byte=  2;
    Shift        : Byte=  3;
    Ctrl         : Byte=  4;
    Alt          : Byte=  8;
    ScrollLock   : Byte= 16;
    NumLock      : Byte= 32;
    CapsLock     : Byte= 64;
    Insert       : Byte=128;

{ alle Prozeduren und Funktionen auf einen Blick }
{ die wichtigsten Befehle:

   z.B. io_ini(COM1,9600);    COM1 mu gro geschriebn sein
        io_close;             mu zum Schlu aufgerufen werden
        io_Write('A');        fr Char
        io_WriteByte(127);    fr Bytes      }


  procedure io_ini( Schnittstelle:comtype; Baudrate: String);
  procedure io_SetRate(r:ratetype);
  procedure io_IntOff;
  procedure io_close;
  function  io_Read : char;
  procedure io_write( ch : char );
  function  io_ModemInput:boolean;
  procedure io_WriteByte(wert:Byte);
  procedure warte_hs(hundertstel: Integer); { Pause in 1/100 Sek.}
  procedure warte(Sekunden: Integer);       { Pause in Sekunden }
  function  KeyState:Byte;                  { Shift,Ctrl,Alt... siehe const }
  function  KeyCode:Integer;                { Tastaturcode lo und hi }




implementation


{----------------------------------------------------------------------------
      This is the interrupt handler for the COM1 or COM2 comports.  Notice
 the restoration of the DS register through a move to the AX from address
 CS:00A0.  The absolute variable "segment" is initialized at the begining
 of the program to contain the value of "DSEG".  The inline statments should
 replace the current ones in the Turbo reference manual.
----------------------------------------------------------------------------}

  procedure io_IntHandler;


  interrupt;

    begin

      inline( $50            { push ax        }
             /$53            { push bx        }
             /$51            { push cx        }
             /$52            { push dx        }    { Save all the registers }
             /$57            { push di        }
             /$56            { push si        }
             /$06            { push es        }
             /$1E            { push ds        });

      tbyte := port[ comport ];               { Get the character in the port}
      lbyte := port[ comport + linestat ];    { Get the status of the port   }
      If ( head < buffsize ) then             { Check bounds of the ring     }
        head := head + 1                      { buffer,  and if smaller then }
      else                                    { increment by one otherwise   }
        head := 0;                            { set to the first element     }
      intbuffer[ head ].o := tbyte;           { Load the buffer w/ the char. }
      port[$20] := $20;                       {                              }
      inline( $1F            { pop ds         }
             /$07            { pop es         }
             /$5E            { pop si         }
             /$5F            { pop di         }
             /$5A            { pop dx         }
             /$59            { pop cx         }   { Restore all reg_set  }
             /$5B            { pop bx         }
             /$58            { pop ax         } )

(*
             /$5D            { pop     bp     }   { Reset the stack to its }
             /$89 /$EC       { mov     sp,bp  }   { proper position        }
             /$5D            { pop     bp     }
             /$CF );         { iret           }   { Return                 } *)
    end;


{-----------------------------------------------------------------------------
      The procedure AskCom gets the comport to comunicate through.
-----------------------------------------------------------------------------}


  procedure io_ini( Schnittstelle:comtype; Baudrate: String);

    const
      bits5=0;
      bits6=1;
      bits7=2;
      bits8=3;
      stopbit1=0;                             { These are constants used     }
      stopbit2=4;                             { to define parity, stop bits, }
      noparity=0;                             { data bits, etc.              }
      parity=8;
      evenparity=16;
      dtrtrue=1;
      rtstrue=2;
      bit3true=8;

    var
      tbyte   : byte;                         { Temporary byte buffer        }
      i       : integer;                      { counter                      }



  begin
    comp:= Schnittstelle;
    if comp in [com1,com2] then begin

      head:=0;                                { Initialize the ring buffer   }
      tail:=0;                                { indexes                      }
      case comp of
        COM1:    comport:=com1base;           { Set the com port to talk to  }
        COM2:    comport:=com2base;
      end;
      tbyte := port[ comport ];               { Read the ports to clear any  }
      tbyte := port[ comport + linestat ];    { error conditions             }

      If Baudrate =  '300'   then io_SetRate(rate300);
      If Baudrate = '1200'   then io_SetRate(rate1200);
      If Baudrate = '2400'   then io_SetRate(rate2400);
      If Baudrate = '4800'   then io_SetRate(rate4800);
      If Baudrate = '9600'   then io_SetRate(rate9600);
      If Baudrate = '19200'  then io_SetRate(rate19200);
      If Baudrate = '38400'  then io_SetRate(rate38400);
      If Baudrate = '57600'  then io_SetRate(rate57600);
      If Baudrate = '115200' then io_SetRate(rate115200);

      port[ comport + linectrl ] := bits8 + stopbit2 + noparity;
                                              { Set the protocall            }
      port[ comport + modemctrl ] := dtrtrue + rtstrue + bit3true;
      port[ comport + intenreg ] := 1;        { Enable com port interrupts   }
      tbyte := port[$21];                     {                              }
      case comp of
        COM1:    begin
                    getintvec(com1_intr,OldVecAddr);  { Save the segment and offset  }
                    setintvec(com1_intr,@io_IntHandler);
                    port[$21]:=tbyte and $ef;         {                              }
                 end;

        COM2:    begin
                    getintvec(com2_intr,OldVecAddr);   { Save the segment and offset  }
                    setintvec(com2_intr,@io_IntHandler);
                    port[$21]:=tbyte and $f7;          {                              }
                 end
      end;
      io_sti;                                     { Enable interrupts            }
    end;

  end;






{-----------------------------------------------------------------------------
      This procedure sets the baud rate of the comport to either 300, 1200,
 2400, 4800, or 9600 baud.  The Divisor latches are set according to the table
 in the IBM hardware technical reference manual ( p. 1-238 ).
-----------------------------------------------------------------------------}

  procedure io_SetRate(r:ratetype);

    var
      tlcr,                                   { Line control register        }
      tdlmsb,                                 { Divisor latch MSB            }
      tdllsb    : byte;                       { Divisor latch LSB            }

    begin
      tdlmsb:=0;                              { Set DL MSB to 0 for 1200,    }
                                              { 4800 and 9600 baud           }
      case r of                               { use case to check baud rate  }
         rate300 : begin                      { Check for 300 baud           }
                     tdlmsb:=1;               { Set DL MSB to 01             }
                     tdllsb:=$80;             { Set DL LSB to 80             }
                   end;
        rate1200 : begin
                     tdllsb:=$60;             { 1200 set LSB to 60           }
                   end;
        rate2400 : begin
                     tdllsb:=$30;               { 2400 set LSB to 30           }
                   end;
        rate4800 : begin
                     tdllsb:=$18;               { 4800 set LSB to 18           }
                   end;
        rate9600 : begin
                     tdllsb:=$0c;               { 0C for 9600 baud             }
                   end;
        rate19200: begin
                     tdllsb:=$06;               { 19200 Baud}
                   end;
        rate38400: begin
                     tdllsb:=$03;               { 38400 Baud}
                   end;
        rate57600: begin
                     tdllsb:=$02;               { 57600 Baud}
                   end;
       rate115200: begin
                     tdllsb:=$01;               { 115200 Baud}
                   end;


      end;

      tlcr:=port[comport+linectrl];           { Get the Line control register}
      port[comport + linectrl] := tlcr or $80;{ Set Divisor Latch Access Bit }
      port[comport]:=tdllsb;                  { in order to access divisor   }
      port[comport+1]:=tdlmsb;                { latches, then store the      }
                                              { values for the desired baud  }
                                              { rate                         }
      port[comport+linectrl]:=tlcr and $7f;   { then clear the DLAB in order }
                                              { to access to the receiver    }
                                              { buffer                       }
    end;





{-----------------------------------------------------------------------------
      This procedure restores the original system values to what they
 were before the interrupt handler was set into action.
-----------------------------------------------------------------------------}

  procedure io_IntOff;

    var
      tbyte:byte;

    begin
      io_cli;                                    { Disable interrupts           }
      tbyte:=port[$21];                       {                              }
      port[comport+intenreg]:=0;              { Disable COM interrupts       }
      If comport=$3f8 then                    { If using COM1: then          }
        begin
          setintvec(com1_intr, oldvecaddr);
          port[$21]:=tbyte or $10;            {                              }
        end
      else
        begin
          setintvec(com2_intr, oldvecaddr);
          port[$21]:=tbyte or $08;            {                              }
        end;
    end;




  procedure io_close;


  begin
    Case comp of

      com1:      io_IntOff;         { Restore the enviornment               }
      com2:      io_IntOff;
      lpt1:               ;
     sync1:

    end;
  end;






{-----------------------------------------------------------------------------
      If the ring buffer indexes are not equal then ReadCom returns the
 char from either the COM1: or COM2: port.  The character is read from the
 ring buffer and is stored in the function result.
-----------------------------------------------------------------------------}

  function io_Read : char;

    begin
      If ( head <> tail ) then           { Check for ring buffer character   }
        begin
          If ( tail < buffsize ) then    { Check the limits of the ring      }
            tail := tail + 1             { and set tail accordingly          }
          else
            tail := 0;
          io_Read := intbuffer[tail].c;  { Get the character                 }
        end;
    end;

{----------------------------------------------------------------------------
      This procedure outputs directly to the communications port the byte
 equivilent of the character to be sent.
----------------------------------------------------------------------------}



  procedure IO_write( ch : char );

    var                           tbyte: byte;                                      i: byte;
                                Zustand: byte;
                                      j: Integer;
                                Timeout: Boolean;
      stunde1,minute1,sekunde1,sek1001,
      stunde2,minute2,sekunde2,sek1002 :  Word;
    const                   TimeoutZeit: Byte=2;



    begin
      tbyte:=ord(ch);                { Change to byte format                }
      If Comp in [com1,com2] then begin
        timeout:= false;
        gettime (stunde1,minute1,sekunde1,sek1001);
        repeat
          j:=0;
          repeat
            j:= Succ(j);
            Zustand:= port[comport+modemstat];
          until ((Zustand and 16)=16) or (j=10000);      { auf CTS warten }

          gettime (stunde2,minute2,sekunde2,sek1002);
          if (sekunde2>sekunde1) and ((sekunde2-sekunde1)>TimeoutZeit) then timeout:= true;
          if (sekunde2<sekunde1) and ((sekunde1-sekunde2)>TimeoutZeit) then timeout:= true;
        until ((Zustand and 16)=16) or timeout;
        If Timeout then write(' Timeout (CTS) ');

        repeat
          Zustand:= port[comport+linestat];
        until (Zustand and 32)=32;               { Sendepuffer leer }
        port[comport]:=tbyte;                    { Output the character }
      end;

      If Comp in [lpt1] then begin
        write(lst,ch);                 { lst, weil bei Zuweisung als Datei }
      end;                             { der Code 26(dez) Probleme macht }

      If Comp in [sync1] then begin
        for i:=1 to 8 do begin
          If (Tbyte and 1)= 1 then
            write(lst,Chr(128))
          else
            write(lst,Chr(0));

          tbyte:= tbyte shr 1;
        end;
      end;
    end;




  procedure io_writealt( ch : char );

    var
      tbyte: byte;
          i: byte;
    Zustand: byte;

    begin
      tbyte:=ord(ch);                { Change to byte format                }
      If Comp in [com1,com2] then begin
        repeat
          Zustand:= port[comport+modemstat];
        until (Zustand and 16)=16;               { auf CTS warten }
        repeat
          Zustand:= port[comport+linestat];
        until (Zustand and 32)=32;               { Sendepuffer leer }
        port[comport]:=tbyte;                    { Output the character }
      end;

      If Comp in [lpt1] then begin
        write(lst,ch);                 { lst, weil bei Zuweisung als Datei }
      end;                             { der Code 26(dez) Probleme macht }

      If Comp in [sync1] then begin
        for i:=1 to 8 do begin
          If (Tbyte and 1)= 1 then
            write(lst,Chr(128))
          else
            write(lst,Chr(0));

          tbyte:= tbyte shr 1;
        end;
      end;
    end;

{---------------------------------------------------------------------------
      when the interrupt routine is called because of a com port interrupt
 the head index is incremented by one,  but does not increment the tail
 index.  This causes the two indexes to be unequal,  and ModemInput to
 become true.
---------------------------------------------------------------------------}

  function io_ModemInput:boolean;
    var
      j: Integer;
      Timeout: Boolean;
      stunde1,minute1,sekunde1,sek1001,
      stunde2,minute2,sekunde2,sek1002 :  Word;
    const
      TimeoutZeit: Byte=2;


    begin
      timeout:= false;
      gettime (stunde1,minute1,sekunde1,sek1001);
      repeat
        j:=0;
        repeat
          j:= Succ(j);
        until ((head<>tail) or (j=10000));

        gettime (stunde2,minute2,sekunde2,sek1002);
        if (sekunde2>sekunde1) and ((sekunde2-sekunde1)>TimeoutZeit) then timeout:= true;
        if (sekunde2<sekunde1) and ((sekunde1-sekunde2)>TimeoutZeit) then timeout:= true;
      until ((head<>tail) or timeout);
      If Timeout then write(' Timeout (Empfang) ');

      If (head<>tail) or Timeout then IO_ModemInput:=true;
    end;




  procedure io_WriteByte(wert:Byte);

  begin
    io_Write(Chr(wert));             { WriteCom erwartet Char }
  end;



  procedure warte_hs(hundertstel: Integer);

  var   stunde1,minute1,sekunde1,sek1001,
        stunde2,minute2,sekunde2,sek1002:  Word;
        i: Integer;
  begin

    gettime (stunde1,minute1,sekunde1,sek1001);
    repeat
      repeat
        gettime (stunde2,minute2,sekunde2,sek1002);
      until sek1002 <> sek1001;
      if sek1002 > sek1001 then
        hundertstel:= hundertstel - (sek1002 - sek1001)
      else
        hundertstel:= hundertstel - (sek1002 + 100 - sek1001);
      sek1001:= sek1002;
    until hundertstel < 0;
  end;



  procedure warte(Sekunden: Integer);

  var     i: Integer;

  begin
    For i:= 1 to Sekunden do
      warte_hs(100);
  end;



function   KeyState:Byte;

begin
  regs.ah := 2+16;           { Status (16: geht nur bei MF-102) }
  Intr($16,regs);            { Tastaturinterrupt aufrufen }
  KeyState:= regs.al;
end;


function   KeyCode:Integer;

begin
  Repeat
    regs.ah := 1+16;                       { Status }
    Intr($16,regs);
  until (regs.flags AND FZero) = 0;
  regs.ah := 16;                           { Tastaturcode }
  Intr($16,regs);
  KeyCode:= regs.ax;
end;



end.
