Program  Demo_fuer_Menuerstellung_mit_IC202_128x64;
Uses     dos,crt,ea_io;


Var      ESC,NUL,CR,LF,FF,OFF,ON,
         Schwarz,Weiss,
         Grau25,Grau50,Grau75,
         Muster,Modus               : Byte;

         Cursor                     : Integer;
         menuNr,MenuBreite          : Byte;
         Kch,Kch0                   : Char;
         Bild: Array[1..5,1..1026] of Char;


Const    BoxX: Byte=  2;
         BoxY: Byte= 23;
    BoxBreite: Byte= 17;
     BoxHoehe: Byte= 40;
        Box2X: Byte= 91;
        Box2Y: Byte= 23;



{*****************************************}
{* Routinen zur Ansteuerung des Displays *}
{*****************************************}


Procedure   Clr_Lcd;
var    Befehl: Byte;
begin
  Befehl:= Ord ('D');
  IO_WriteByte(Befehl);
  Befehl:= Ord ('L');
  IO_WriteByte(Befehl);
end;

Procedure   Invertieren(X1,Y1,X2,Y2:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('I');
  IO_WriteByte(Befehl);
  IO_WriteByte(X1);
  IO_WriteByte(Y1);
  IO_WriteByte(X2);
  IO_WriteByte(Y2);
end;

Procedure   Font(FontNr,FontX,FontY:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('F');
  IO_WriteByte(Befehl);
  IO_WriteByte(FontNr);
  IO_WriteByte(FontX);
  IO_WriteByte(FontY);
end;

Procedure   Textmodus(Richtung:Char;Verknuepfung,Muster:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('T');
  IO_WriteByte(Befehl);
  IO_WriteByte(Ord(Richtung));
  IO_WriteByte(Verknuepfung);
  IO_WriteByte(Muster);
end;

Procedure   String_Out(X,Y:Byte;Wort:String);
var    Stelle: Byte;
       Befehl: Byte;
    Buchstabe: Byte;
begin
  Befehl:= Ord ('Z');
  IO_WriteByte(Befehl);
  IO_WriteByte(X);
  IO_WriteByte(Y);
  For Stelle:=1 to Length(Wort) do begin
    Buchstabe:= Ord(Wort[Stelle]);
    IO_WriteByte(Buchstabe);
  end;
  IO_WriteByte(NUL);
end;


Procedure   Save(X1,Y1,X2,Y2,Nr:Byte);
var   Breite,Hoehe: Char;
          Laenge,i: Integer;

begin
  IO_Write('H');
  IO_WriteByte(X1);
  IO_WriteByte(Y1);
  IO_WriteByte(X2);
  IO_WriteByte(Y2);

  Repeat until IO_Modeminput;
  Breite:= IO_Read;
  Repeat until IO_Modeminput;
  Hoehe:= IO_Read;
    Laenge:= Ord(Breite)* ((Ord(Hoehe)+7) div 8);
    Bild[Nr,1]:= Breite;
    Bild[Nr,2]:= Hoehe;
    For i:=3 to Laenge+2 do begin
      Repeat until IO_Modeminput;
      Bild[Nr,i]:= IO_Read
    end;
end;

Procedure   Restore(X,Y,Nr:Byte);
var   Breite,Hoehe: Char;
          Laenge,i: Integer;
begin
  IO_Write('U');
  IO_WriteByte(X);
  IO_WriteByte(Y);
    Breite:= Bild[Nr,1];
    Hoehe:= Bild[Nr,2];
    Laenge:= Ord(Breite)* ((Ord(Hoehe)+7) shr 3);
    IO_Write(Breite);
    IO_Write(Hoehe);
    For i:=3 to Laenge+2 do IO_Write(Bild[Nr,i]);


end;

Procedure   Box(X1,Y1,X2,Y2,Muster:Byte);
var    Befehl: Byte;
begin
  Befehl:= Ord ('O');
  IO_WriteByte(Befehl);
  IO_WriteByte(X1);
  IO_WriteByte(Y1);
  IO_WriteByte(X2);
  IO_WriteByte(Y2);
  IO_WriteByte(Muster);
end;

Procedure   Loeschen(X1,Y1,X2,Y2:Byte);

begin
  IO_Write('L');
  IO_WriteByte(X1);
  IO_WriteByte(Y1);
  IO_WriteByte(X2);
  IO_WriteByte(Y2);
end;

Procedure   Gerade(X1,Y1,X2,Y2:Byte);

begin
  IO_Write('G');
  IO_WriteByte(X1);
  IO_WriteByte(Y1);
  IO_WriteByte(X2);
  IO_WriteByte(Y2);
end;

Function   Pulldown(X,Y:Byte;Eintraege:String):Integer; {-1:links,-2:rechts}
                                                        { 0: ESC, 1..:Eintrag}
var    Anztexte,Stelle,
       Stelle2,MaxChar,
                 TextNr: Byte;
                Eintrag: String;
              EintragNr: Byte;
               kch0,kch: Char;
               Breite,Hoehe: Byte;
const     Zeichenbreite: Byte=4;
           Zeichenhoehe: Byte=6;
           Trennzeichen: Char=';';

begin
  Font(1,1,1);
  Textmodus('R',1,schwarz);

  If Eintraege <> '' then begin
    Stelle2:=0;
    MaxChar:=0;
    Anztexte:=1;
    For Stelle:=1 to Length(Eintraege) do begin
      Stelle2:= Succ(Stelle2);
      If Eintraege[Stelle]=Trennzeichen then begin
        Anztexte:=Succ(Anztexte);
        Stelle2:= Pred(Stelle2);
        If MaxChar<Stelle2 then MaxChar:=Stelle2;
        Stelle2:=0;
      end;
    end;
    If MaxChar<Stelle2 then MaxChar:=Stelle2;

    Save(X,Y,X+2+MaxChar*Zeichenbreite,Y+2+Anztexte*Zeichenhoehe,1);
    Box(X,Y,X+2+MaxChar*Zeichenbreite,Y+2
    +Anztexte*Zeichenhoehe,weiss);
    Eintrag:='';
    TextNr:=0;
    For Stelle:=1 to Length(Eintraege) do begin
      If Eintraege[Stelle]<>Trennzeichen then
        Eintrag:= Eintrag+Eintraege[Stelle]
      else begin
        String_Out(X+2,y+2+TextNr*Zeichenhoehe,Eintrag);
        Eintrag:='';
        TextNr:= Succ(TextNr);
      end;
    end;
    String_Out(X+2,y+2+TextNr*Zeichenhoehe,Eintrag);

    EintragNr:=0;

    Breite:= MaxChar*Zeichenbreite+1;
    Hoehe:= Zeichenhoehe;
    Invertieren(X+1,Y+1+EintragNr*Hoehe,X+Breite,Y+1+(EintragNr+1)*Hoehe);

    Repeat
      kch0 := readkey;
      if kch0=#0 then begin
        kch:= readkey;
        case kch of
          chr(72):  begin                              { up }
                      if EintragNr>0 then begin
                        Invertieren(X+1,Y+1+EintragNr*Hoehe,X+Breite,Y+1+(EintragNr+1)*Hoehe);
                        EintragNr:= Pred(EintragNr);
                        Invertieren(X+1,Y+1+EintragNr*Hoehe,X+Breite,Y+1+(EintragNr+1)*Hoehe);
                      end;
                    end;
          chr(80):  begin                              { down }
                      if EintragNr<TextNr then begin
                        Invertieren(X+1,Y+1+EintragNr*Hoehe,X+Breite,Y+1+(EintragNr+1)*Hoehe);
                        EintragNr:= Succ(EintragNr);
                        Invertieren(X+1,Y+1+EintragNr*Hoehe,X+Breite,Y+1+(EintragNr+1)*Hoehe);
                      end;
                    end;
        end
      end
    until (kch0=#27) or (kch0=#13) or (kch=#75) or (kch=#77);
    if kch0=#27 then Pulldown:=0;
    if kch0=#13 then Pulldown:=Succ(EintragNr);
    if kch=#75 then Pulldown:=-1;                      { links }
    if kch=#77 then Pulldown:=-2;                      { rechts }
    Restore(X,Y,1);

  end;
end;


Procedure       Testbox(Modus,Muster:Byte);

begin
  Loeschen(Box2X,Box2Y,Box2X+2*BoxBreite,BoxY+Boxhoehe);
  box(BoxX,BoxY,BoxX+BoxBreite,BoxY+Boxhoehe,weiss);
  box(BoxX+BoxBreite,BoxY,BoxX+2*BoxBreite,BoxY+Boxhoehe,schwarz);

  Textmodus('R',1,schwarz);
  Font(2,1,1);
  String_Out(44,40,'+');
  String_Out(80,40,'=');

  box(Box2X,Box2Y,Box2X+BoxBreite,Box2Y+Boxhoehe,weiss);
  box(Box2X+BoxBreite,Box2Y,Box2X+2*BoxBreite,Box2Y+Boxhoehe,schwarz);

  Textmodus('R',4,Muster);
  Font(3,3,2);
  String_Out(53,27,'I');
  Textmodus('R',Modus,Muster);
  String_Out(Box2X+5,Box2Y+4,'I');
end;





Procedure    Schalter_lesen;
var           Baudrate: String;
         Schnittstelle: String;

begin
  Schnittstelle:= 'COM1';
  Baudrate:= '1200';
  If ParamCount <> 0 then begin
    For i:=1 to ParamCount do begin
      If ParamStr(i) =     '1' then Schnittstelle:= 'COM1';
      If ParamStr(i) =     '2' then Schnittstelle:= 'COM2';
      If ParamStr(i) =   '300' then      Baudrate:= '300';
      If ParamStr(i) =  '1200' then      Baudrate:= '1200';
      If ParamStr(i) =  '2400' then      Baudrate:= '2400';
      If ParamStr(i) =  '4800' then      Baudrate:= '4800';
      If ParamStr(i) =  '9600' then      Baudrate:= '9600';
      If ParamStr(i) = '19200' then      Baudrate:= '19200';
      If ParamStr(i) = '38400' then      Baudrate:= '38400';
      If ParamStr(i) = '57600' then      Baudrate:= '57600';
      If ParamStr(i) ='115200' then      Baudrate:= '115200';
    end;
  end;

  If Schnittstelle = 'COM1' then IO_Ini(COM1,Baudrate); { Schnittstelle des PCs initialisieren }
  If Schnittstelle = 'COM2' then IO_Ini(COM2,Baudrate);
end;


{*****************************************************}
{*                                                   *}
{*            H A U P T P R O G R A M M              *}
{*                                                   *}
{*****************************************************}

Var      Taste : Char;

BEGIN
  ESC     := 27;                { Konstanten definieren }
  NUL     :=  0;
  CR      := 13;
  LF      := 10;
  FF      := 12;
  OFF     :=  0;
  ON      :=  1;
  Weiss   :=  0;
  Schwarz :=  1;
  Grau25  :=  2;
  Grau50  :=  3;
  Grau50  :=  4;
  Grau75  :=  5;

  Schalter_lesen;

  ClrScr;
  Writeln ('****************************************************');
  Writeln ('*                                                  *');
  Writeln ('*                  MENU DEMO V1.0                  *');
  Writeln ('*                      21.4.97                     *');
  Writeln ('*                                                  *');
  Writeln ('*  Anschluss an COM1: EA IC 202 auf 1200 Baud      *');
  Writeln ('*  oder z.B. "MENUDEMO 2 9600" fr COM2/9600 Baud  *');
  Writeln ('*                                                  *');
  Writeln ('****************************************************');
  Writeln;
  Writeln;
  Writeln;
  Writeln ('Mit den Cursortasten links/rechts/auf/ab whlen Sie aus dem Menu');
  Writeln ('auf dem LCD Display den Modus und das Fllmuster aus.');
  Writeln;
  Writeln ('ESC beendet das Demoprogramm.');

  Clr_Lcd;                              { Display lschen }

  MenuNr:= 0;
  MenuBreite:= 25;
  Cursor:= 0;

  Font (1,1,1);                         { Zeichensatz 4x6 }
  Textmodus('R',1,schwarz);
  String_Out(7,0,'DEMO: FLLMUSTER/VERKNPFUNG');
  Gerade(0,6,127,6);

  Font (1,1,1);                         { Zeichensatz 4x6 }
  Textmodus('R',1,schwarz);
  String_Out(1,8,'MODUS');
  String_Out(MenuBreite+1,8,'MUSTER');

  Invertieren(MenuNr*MenuBreite,7,(MenuNr+1)*MenuBreite-1,13);

  Modus:= 3;
  Muster:= 1;
  Testbox(Modus,Muster);

  Repeat
    If Cursor=-1 then kch:=#75
    else if Cursor=-2 then kch:=#77
    else begin
      kch0 := readkey;
      if kch0=#0 then kch:= readkey;
    end;
      case kch of
        chr(72):  begin                              { up }
                  end;
        chr(80):  begin                              { down }
                    If MenuNr=0 then begin
                      Cursor:=Pulldown(0,14,'SETZEN;LSCHEN;INVERS;REPLACE;I-REPLACE');
                      If Cursor in [1..5] then begin
                        Modus:= Cursor;
                        Testbox(Modus,Muster);
                      end;
                    end;
                    If MenuNr=1 then begin
                      Cursor:=Pulldown(Menubreite,14,'SCHWARZ;25%;50%;75%;45-RECHTS;45-LINKS;45-KREUZ');
                      If Cursor in [1..7] then begin
                        Muster:= Cursor;
                        Testbox(Modus,Muster);
                      end;
                    end;
                  end;
        chr(75):  begin                              { links }
                   If MenuNr>0 then begin
                     Invertieren(MenuNr*MenuBreite,7,(MenuNr+1)*MenuBreite-1,13);
                     MenuNr:=Pred(MenuNr);
                     Invertieren(MenuNr*MenuBreite,7,(MenuNr+1)*MenuBreite-1,13);
                   end;
                   Cursor:=1000;
                  end;
        chr(77):  begin                              { rechts }
                   If MenuNr<1 then begin
                     Invertieren(MenuNr*MenuBreite,7,(MenuNr+1)*MenuBreite-1,13);
                     MenuNr:=Succ(MenuNr);
                     Invertieren(MenuNr*MenuBreite,7,(MenuNr+1)*MenuBreite-1,13);
                   end;
                   Cursor:=1000;
                  end;

      end;
  until (kch0=#27) or (cursor=0);
  Writeln ('Ende des Demos');
  IO_Close;
End.
