Program  Harcopyfunktion_fuer_High_Level_Grafikkontroller;
Uses     dos,crt,ea_io;

{ V1.1: (26.6.97): Displaygren Abfrage, Alt-X, TimeOut in EA_IO eingebaut}
{ V1.2: (15.9.97): Displaytyp H/V wird abgefragt }


Var      ESC,NUL,CR,LF,FF,OFF,ON,
         Schwarz,Weiss,
         Grau25,Grau50,Grau75,
         Muster,Modus               : Byte;

         Cursor                     : Integer;
         menuNr,MenuBreite          : Byte;
         Kch,Kch0                   : Char;
         Bild: Array[1..5,1..1026] of Char;
         Taste                      : Integer;  { Tastaturabfrage }
         Control                    : Byte;
         X1,X2,Y1,Y2                : Byte;
         Dateiname                  : String;
         XMAX                       : Byte;
         YMAX                       : Byte;
         HV                         : Char;
         Baudrate                   : String;
         Schnittstelle              : String;


Const    BoxX: Byte=  2;
         BoxY: Byte= 23;
    BoxBreite: Byte= 17;
     BoxHoehe: Byte= 57;
        Box2X: Byte= 91;
        Box2Y: Byte= 23;


{*****************************************}
{* Routinen zur Ansteuerung des Displays *}
{*****************************************}


Procedure   Clr_Lcd;
  var    Befehl: Byte;
  begin
    Befehl:= Ord ('D');
    IO_WriteByte(Befehl);
    Befehl:= Ord ('L');
    IO_WriteByte(Befehl);
  end;

Procedure   Invertieren(X1,Y1,X2,Y2:Byte);
  var    Befehl: Byte;
  begin
    Befehl:= Ord ('I');
    IO_WriteByte(Befehl);
    IO_WriteByte(X1);
    IO_WriteByte(Y1);
    IO_WriteByte(X2);
    IO_WriteByte(Y2);
  end;

Procedure   Font(FontNr,FontX,FontY:Byte);
  var    Befehl: Byte;
  begin
    Befehl:= Ord ('F');
    IO_WriteByte(Befehl);
    IO_WriteByte(FontNr);
    IO_WriteByte(FontX);
    IO_WriteByte(FontY);
  end;

Procedure   Textmodus(Richtung:Char;Verknuepfung,Muster:Byte);
  var    Befehl: Byte;
  begin
    Befehl:= Ord ('T');
    IO_WriteByte(Befehl);
    IO_WriteByte(Ord(Richtung));
    IO_WriteByte(Verknuepfung);
    IO_WriteByte(Muster);
  end;

Procedure   Grafikmodus(Verknuepfung:Byte);
  var    Befehl: Byte;
  begin
    IO_Write('V');
    IO_WriteByte(Verknuepfung);
  end;

Procedure   String_Out(X,Y:Byte;Wort:String);
  var    Stelle: Byte;
         Befehl: Byte;
      Buchstabe: Byte;
  begin
    Befehl:= Ord ('Z');
    IO_WriteByte(Befehl);
    IO_WriteByte(X);
    IO_WriteByte(Y);
    For Stelle:=1 to Length(Wort) do begin
      Buchstabe:= Ord(Wort[Stelle]);
      IO_WriteByte(Buchstabe);
    end;
    IO_WriteByte(NUL);
  end;


Procedure   Save(X1,Y1,X2,Y2,Nr:Byte);
  var   Breite,Hoehe: Char;
            Laenge,i: Integer;

  begin
    IO_Write('H');
    IO_WriteByte(X1);
    IO_WriteByte(Y1);
    IO_WriteByte(X2);
    IO_WriteByte(Y2);

    Repeat until IO_Modeminput;
    Breite:= IO_Read;
    Repeat until IO_Modeminput;
    Hoehe:= IO_Read;
      Laenge:= Ord(Breite)* ((Ord(Hoehe)+7) div 8);
      Bild[Nr,1]:= Breite;
      Bild[Nr,2]:= Hoehe;
      For i:=3 to Laenge+2 do begin
        Repeat until IO_Modeminput;
        Bild[Nr,i]:= IO_Read
      end;
  end;

Procedure   Restore(X,Y,Nr:Byte);
  var   Breite,Hoehe: Char;
            Laenge,i: Integer;
  begin
    IO_Write('U');
    IO_WriteByte(X);
    IO_WriteByte(Y);
      Breite:= Bild[Nr,1];
      Hoehe:= Bild[Nr,2];
      Laenge:= Ord(Breite)* ((Ord(Hoehe)+7) shr 3);
      IO_Write(Breite);
      IO_Write(Hoehe);
      For i:=3 to Laenge+2 do IO_Write(Bild[Nr,i]);


  end;

Procedure   Box(X1,Y1,X2,Y2,Muster:Byte);
  var    Befehl: Byte;
  begin
    Befehl:= Ord ('O');
    IO_WriteByte(Befehl);
    IO_WriteByte(X1);
    IO_WriteByte(Y1);
    IO_WriteByte(X2);
    IO_WriteByte(Y2);
    IO_WriteByte(Muster);
  end;

Procedure   Rechteck(X1,Y1,X2,Y2:Byte);
  var    Befehl: Byte;
  begin
    Befehl:= Ord ('R');
    IO_WriteByte(Befehl);
    IO_WriteByte(X1);
    IO_WriteByte(Y1);
    IO_WriteByte(X2);
    IO_WriteByte(Y2);
  end;

Procedure   Loeschen(X1,Y1,X2,Y2:Byte);
  begin
    IO_Write('L');
    IO_WriteByte(X1);
    IO_WriteByte(Y1);
    IO_WriteByte(X2);
    IO_WriteByte(Y2);
  end;

Procedure   Gerade(X1,Y1,X2,Y2:Byte);
  begin
    IO_Write('G');
    IO_WriteByte(X1);
    IO_WriteByte(Y1);
    IO_WriteByte(X2);
    IO_WriteByte(Y2);
  end;


Procedure    Schalter_lesen;

  begin
    Schnittstelle:= 'COM1';
    Baudrate:= '1200';
    If ParamCount <> 0 then begin
      For i:=1 to ParamCount do begin
        If ParamStr(i) =     '1' then Schnittstelle:= 'COM1';
        If ParamStr(i) =     '2' then Schnittstelle:= 'COM2';
        If ParamStr(i) =   '300' then      Baudrate:= '300';
        If ParamStr(i) =  '1200' then      Baudrate:= '1200';
        If ParamStr(i) =  '2400' then      Baudrate:= '2400';
        If ParamStr(i) =  '4800' then      Baudrate:= '4800';
        If ParamStr(i) =  '9600' then      Baudrate:= '9600';
        If ParamStr(i) = '19200' then      Baudrate:= '19200';
        If ParamStr(i) = '38400' then      Baudrate:= '38400';
        If ParamStr(i) = '57600' then      Baudrate:= '57600';
        If ParamStr(i) ='115200' then      Baudrate:= '115200';
      end;
    end;
    If Schnittstelle = 'COM1' then IO_Ini(COM1,Baudrate); { Schnittstelle des PCs initialisieren }
    If Schnittstelle = 'COM2' then IO_Ini(COM2,Baudrate);
  end;


  Procedure DisplayXY;
  begin
    GotoXY (33,13);
    Write ('(',X1,'/',Y1,')','   ');
    GotoXY (33,14);
    Write ('(',X2,'/',Y2,')','   ');
    GotoXY (1,21);
    Delline;                           { lscht evtl. Dateinamen }
    Delline;
    Delline;
  end;


  procedure      Hardcopy;           { Bilddaten holen }
  var     Wert,
          Breite,Hoehe        : Byte;
          Datei               : File of Byte;
          JN                  : Char;
          OK                  : Boolean;
          i,Laenge            : Integer;
  begin
    OK:= true;
    GotoXY(1,21);
    Delline;
    Delline;
    Delline;
    Write('Dateiname: ');
    Readln(Dateiname);
    If Dateiname<>'' then begin
      Assign (Datei,DateiName);
      {$I-}
      Reset (Datei);                 { testen ob Datei vorhanden }
      {$I+}
      If IOResult=0 then begin
        write('Datei bereits vorhanden; berschreiben? (J/N)');
        JN:= Readkey; Write (JN);
        If Upcase(JN)='J' then OK:= true
        else begin
          OK:= false;
          GotoXY (1,20);
          Delline;                           { lscht evtl. Dateinamen }
          Delline;
        end;
      end else OK:= true;

      If OK then begin
        {$I-}
        Rewrite (Datei);
        {$I+}

        If IOResult= 0 then begin
          writeln;
          write('Hole Daten fr "',DateiName,'"');

          Rechteck(X1,Y1,X2,Y2);
          IO_Write ('H');
          IO_WriteByte (X1);
          IO_WriteByte (Y1);
          IO_WriteByte (X2);
          IO_WriteByte (Y2);

          Repeat until IO_Modeminput;
          Breite:= Ord(IO_Read);
          Write (Datei,Breite);
          Repeat until IO_Modeminput;
          Hoehe:= Ord(IO_Read);
          Write (Datei,Hoehe);
          If HV='V' then Laenge:= Breite* ((Hoehe+7) div 8);
          If HV='H' then Laenge:= Hoehe* ((Breite+7) div 8);
          For i:=1 to Laenge do begin
            Repeat until IO_Modeminput;
            Wert:= Ord(IO_Read);
            Write (Datei,Wert);
            If INT(i/18)=(i/18) then write ('.');
          end;
          write ('OK');
          Close (Datei);
          Rechteck(X1,Y1,X2,Y2);
        end else writeln ('kann die Datei "',DateiName,'" nicht erstellen!');
      end;
    end;
  end;



Procedure   Displaytyp;
  begin
    IO_Write('?');
    Repeat until IO_Modeminput;              { Breite in Pixeln }
    XMAX:= Ord(IO_Read)-1;
    Repeat until IO_Modeminput;              { Hhe in Pixeln }
    YMAX:= Ord(IO_Read)-1;
    Repeat until IO_Modeminput;              { Horizontal/Vertikal }
    HV:= IO_Read;
  end;

{*****************************************************}
{*                                                   *}
{*            H A U P T P R O G R A M M              *}
{*                                                   *}
{*****************************************************}


BEGIN
  ESC     := 27;                { Konstanten definieren }
  NUL     :=  0;
  CR      := 13;
  LF      := 10;
  FF      := 12;
  OFF     :=  0;
  ON      :=  1;
  Weiss   :=  0;
  Schwarz :=  1;
  Grau25  :=  2;
  Grau50  :=  3;
  Grau50  :=  4;
  Grau75  :=  5;

  Schalter_lesen;

  ClrScr;
  Writeln ('****************************************************');
  Writeln ('*                  HardCopy V1.2                   *');
  Writeln ('*                     15.9.97                      *');
  Writeln ('*                                                  *');
  Writeln ('*      fr alle High-Level Grafikkontroller        *');
  Writeln ('*      und alle Grafikeinheiten EA GExxx-V24       *');
  Writeln ('*                                                  *');
  Writeln ('*         Anschluss an COM1 mit 1200 Baud          *');
  Writeln ('*  oder z.B. "HARDCOPY 2 9600" fr COM2/9600 Baud  *');
  Writeln ('****************************************************');
  Writeln;
  Writeln;
  Writeln ('obere Ecke.....Shift-Cursor.....');
  Writeln ('untere Ecke.....Ctrl-Cursor.....');
  Writeln ('ges. Bereich.........Cursor.....');
  Writeln;
  Writeln ('Mit Return wird der gewhlte Ausschnitt angefordert.');
  Writeln ('ESC oder Alt-X beenden das Programm.');



  Displaytyp;
  Writeln ('Angeschlossenes Display: ',XMAX+1,' x ',YMAX+1,' Pixel');
  Writeln ('Schnittstelle ',Schnittstelle,':',Baudrate);

  X1:= 0;                              { Anfagnskoordinaten }
  Y1:= 0;
  X2:= XMAX;
  Y2:= YMAX;
  DisplayXY;                            { Koordinaten anzeigen }
  Grafikmodus(3);                       { Exor }
  Rechteck (X1,Y1,X2,Y2);


  Repeat
      Taste:= KeyCode;
      Control:= KeyState and 15;            { NumLock etc. ausmaskieren}

      If (Control=0) and (Taste=7181) then Hardcopy;         { Return }

      If Control=0 then begin                     { ohne Shift oder Ctrl }
        case hi(taste) of
          72:  begin                              { up }
                 If (Y1 > 0) then begin
                   Rechteck(X1,Y1,X2,Y2);
                   Y1:= Pred(Y1);
                   Y2:= Pred(Y2);
                   DisplayXY;
                   Rechteck(X1,Y1,X2,Y2);
                 end;
               end;
          80:  begin                              { down }
                 If (Y2 < YMAX) then begin
                   Rechteck(X1,Y1,X2,Y2);
                   Y1:= Succ(Y1);
                   Y2:= Succ(Y2);
                   DisplayXY;
                   Rechteck(X1,Y1,X2,Y2);
                 end;
               end;
          75:  begin                              { links }
                 If (X1 > 0) then begin
                   Rechteck(X1,Y1,X2,Y2);
                   X1:= Pred(X1);
                   X2:= Pred(X2);
                   DisplayXY;
                   Rechteck(X1,Y1,X2,Y2);
                 end;
               end;
          77:  begin                              { rechts }
                 If (X2 < XMAX) then begin
                   Rechteck(X1,Y1,X2,Y2);
                   X1:= Succ(X1);
                   X2:= Succ(X2);
                   DisplayXY;
                   Rechteck(X1,Y1,X2,Y2);
                 end;
               end;
        end;
      end;

      If Control=Ctrl then begin                             { Ctrl }
        case hi(taste) of
         141:  begin                                         { up }
                 If (Y2 > 1) and (Y2 > Y1+2) then begin
                   Gerade(X1,Y2,X2,Y2);
                   Y2:= Pred(Y2);
                   DisplayXY;
                   Gerade(X1+1,Y2,X2-1,Y2);
                 end;
               end;
         145:  begin                                         { down }
                 If (Y2 < YMAX) then begin
                   Gerade(X1+1,Y2,X2-1,Y2);
                   Y2:= Succ(Y2);
                   DisplayXY;
                   Gerade(X1,Y2,X2,Y2);
                 end;
               end;
         115:  begin                                         { links }
                 If (X2 > 1) and (X2 > X1+2) then begin
                   Gerade(X2,Y1,X2,Y2);
                   X2:= Pred(X2);
                   DisplayXY;
                   Gerade(X2,Y1+1,X2,Y2-1);
                 end;
               end;
         116:  begin                                         { rechts }
                 If (X2 < XMAX) then begin
                   Gerade(X2,Y1+1,X2,Y2-1);
                   X2:= Succ(X2);
                   DisplayXY;
                   Gerade(X2,Y1,X2,Y2);
                 end;
               end;
        end;
      end;

      If (Control and 3) <> 0 then begin          { L-Shift oder R-Shift }
        case hi(taste) of
          72:  begin                              { up }
                 If (Y1 > 0) then begin
                   Gerade(X1+1,Y1,X2-1,Y1);
                   Y1:= Pred(Y1);
                   DisplayXY;
                   Gerade(X1,Y1,X2,Y1);
                 end;
               end;
          80:  begin                              { down }
                 If (Y1 < Y2-2) then begin
                   Gerade(X1,Y1,X2,Y1);
                   Y1:= Succ(Y1);
                   DisplayXY;
                   Gerade(X1+1,Y1,X2-1,Y1);
                 end;
               end;
          75:  begin                              { links }
                 If (X1 > 0) then begin
                   Gerade(X1,Y1+1,X1,Y2-1);
                   X1:= Pred(X1);
                   DisplayXY;
                   Gerade(X1,Y1,X1,Y2);
                 end;
               end;
          77:  begin                              { rechts }
                 If (X1 < X2-2) then begin
                   Gerade(X1,Y1,X1,Y2);
                   X1:= Succ(X1);
                   DisplayXY;
                   Gerade(X1,Y1+1,X1,Y2-1);
                 end;
               end;
        end;
      end;
  until ((Control=0) and (lo(Taste)=27)) or ( ((Control and 8)=8) and (hi(Taste)=45));
  Rechteck(X1,Y1,X2,Y2);
  Writeln ('Ende');
  IO_Close;
End.
